include:
  - project: 'th6public/shared/ci-templates'
    ref: main
    file: 
      - 'th6.kaniko.gitlab-ci-template.yml'
      - 'ci-autoversion/th6.autoversion.common.yml'
  - template: Jobs/Container-Scanning.gitlab-ci.yml

container_scanning:
  variables:
    # SECURE_LOG_LEVEL: debug
    GIT_STRATEGY: fetch
  extends:
    - .base-job
  before_script:
    - !reference [.get-version]
    - ls -la
    - pwd
    - |
      if [ "$IMAGETAG" = "release" ]; then
          export CS_IMAGE="${CI_REGISTRY_IMAGE}:${VERSION}"
        else \
          export CS_IMAGE="${CI_REGISTRY_IMAGE}:${IMAGETAG}"
      fi
    - echo "container_scanning | $VERSION |$CS_DEFAULT_BRANCH_IMAGE | $CS_IMAGE "


workflow:
  rules:
    - if: $CI_MERGE_REQUEST_ID
      when: never
    - if: $CI_COMMIT_TAG
      when: never 
    - when: always
    
variables:
  IMAGETAG:
    description: "image tag" 
    value: "latest" 
    options:
      - latest
      - release
      - snapshot
  BUMPMESSAGE:
    description: "semantic-versioning #major.#minor.#patch" 
    value: "#patch" 
.base-job:
  tags:
    - "th6-large"

auto-version:
  variables:
    BUMP_MESSAGE: $BUMPMESSAGE
  extends:
    - .auto-version
    - .base-job

kaniko-build:
  tags:
    - "th6-large"
  variables:
    GODEBUG: "http2client=0"
  before_script:
    - !reference [.get-version]
    - |
      if [ "$IMAGETAG" = "release" ]; then
          export IMAGE_TAG="${CI_REGISTRY_IMAGE}:${VERSION}"
        else \
          export IMAGE_TAG="${CI_REGISTRY_IMAGE}:${IMAGETAG}"
      fi
    - echo "kaniko-build | $VERSION |$IMAGE_TAG"

create-tag:
  variables:
    BUMP_MESSAGE: $BUMPMESSAGE
  extends:
    - .create-tag
    - .base-job
  stage: build
  before_script:
    - !reference [.get-version]
    - |
      if [ "$IMAGETAG" = "release" ]; then
          export CREATETAG="YES"
        else \
          export CREATETAG="NO"
      fi
    - echo "create-tag | $VERSION |$IMAGE_TAG"
